/*
 * DatabaseAccess.cpp
 *
 * Heart of the Windows CE mail password recovery
 * Author: Nicolas RUFF - 2006
 *
 * You are free to copy and/or redistribute this code as long as you give credits
 *
 */

#include "stdafx.h"
#include "GetPassword.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include <wincrypt.h>


void read_database_data(TCHAR *message) {

	// Temporary string (yeah I know this is bad :)
	TCHAR mystr[256];

	swprintf( message, TEXT("Messages:\r\n") );

	// 1. CeOpenDatabase()

	CEOID db_oid = 0;
	
	HANDLE myDB = CeOpenDatabase(
		&db_oid,				// Object identifier
		TEXT("pmailFolders"),	// Database name
		0,						// Primary key identifier
		CEDB_AUTOINCREMENT,		// Increment position after each access
		NULL					// Notify window
	);
	
	if ( myDB == INVALID_HANDLE_VALUE )
		return;

	// 2. parse all records using ReadRecord

	while (TRUE) {

		WORD cntProps = 0;
		LPBYTE buffer = NULL;
		DWORD buffersize;
		CEOID rec_oid;

		rec_oid = CeReadRecordProps(
			myDB,				// Database
			CEDB_ALLOWREALLOC,	// Flags
			&cntProps,			// Number of properties in array
			NULL,				// Array of properties
			&buffer,			// Output buffer (will be LocalAlloc'ed)
			&buffersize			// Output buffer size
		);

		if (rec_oid == 0) {
			swprintf( mystr, TEXT("Read error=%d\r\n"), GetLastError() );
			wcscat( message, mystr );
			return;
		}

		// 3. look for property in record

		CEPROPVAL *props = (CEPROPVAL *)buffer;

		for (int i=0; i<cntProps; i++) {

			// Looking for the right BLOB

			if (props[i].propid == 0x83040041) {

				CEBLOB *ceb = (CEBLOB*)(&props[i].val);

				// Decrypt BLOB

				TCHAR password[] = TEXT("Software\\Microsoft\\Inbox\\Svc");
				DATA_BLOB entropy;
				entropy.cbData = 0x38;
				entropy.pbData = (unsigned char *)password;
				DATA_BLOB output_blob;
				BOOL rc;

				memset( &output_blob, 0, sizeof(DATA_BLOB) );

				rc = CryptUnprotectData(
					(DATA_BLOB*)ceb,
					NULL,
					&entropy,
					NULL,
					NULL,
					0x20000000,
					&output_blob
				);

				if (!rc) {
					swprintf( mystr, TEXT("CryptUnprotectData error=%d"), GetLastError() );
					wcscat( message, mystr );
				}

				// Display BLOB string (decrypted)

				swprintf( mystr, TEXT("%s\r\n"), output_blob.pbData );
				wcscat( message, mystr );

			} // end if

		} // end for
	
	} // end while

	return;
}